[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 9. Invoking Bison

The usual way to invoke Bison is as follows:

    bison infile

Here infile is the grammar file name, which usually ends in ``.y`'. The parser file's name is made by replacing the ``.y`' with ``.tab.c`'. Thus, the ``bison foo.y`' filename yields ``foo.tab.c`', and the ``bison hack/foo.y`' filename yields ``hack/foo.tab.c`'.

9.1 Bison Options |  | All the options described in detail, in alphabetical order by short options.
9.2 Option Cross Key |  | Alphabetical list of long options.
9.3 Invoking Bison under VMS |  | Bison command syntax on VMS.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 9.1 Bison Options

Bison supports both traditional single-letter options and mnemonic long option names. Long option names are indicated with ``--`' instead of ``-`'. Abbreviations for option names are allowed as long as they are unique. When a long option takes an argument, like ``--file-prefix`', connect the option name and the argument with ``=`'.

Here is a list of options that can be used with Bison, alphabetized by short option. It is followed by a cross key alphabetized by long option.

``-b file-prefix`'
``--file-prefix=prefix`'
  Specify a prefix to use for all Bison output file names. The names are chosen as if the input file were named ``prefix.c`'.

``-d`'
``--defines`'
  Write an extra output file containing macro definitions for the token type names defined in the grammar and the semantic value type `YYSTYPE`, as well as a few `extern` variable declarations.

  If the parser output file is named ``name.c`' then this file is named ``name.h`'.

  This output file is essential if you wish to put the definition of `yylex` in a separate source file, because `yylex` needs to be able to refer to token type codes and the variable `yylval`. See section Semantic Values of Tokens.

``-l`'
``--no-lines`'
  Don't put any `#line` preprocessor commands in the parser file. Ordinarily Bison puts them in the parser file so that the C compiler and debuggers will associate errors with your source file, the grammar file. This option causes them to associate errors with the parser file, treating it as an independent source file in its own right.

``-n`'
``--no-parser`'
  Do not include any C code in the parser file; generate tables only. The parser file contains just `#define` directives and static variable declarations.

  This option also tells Bison to write the C code for the grammar actions into a file named ``filename.act`', in the form of a brace-surrounded body fit for a `switch` statement.

``-o outfile`'
``--output-file=outfile`'
  Specify the name outfile for the parser file.

  The other output files' names are constructed from outfile as described under the ``-v`' and ``-d`' options.

``-p prefix`'
``--name-prefix=prefix`'
  Rename the external symbols used in the parser so that they start with prefix instead of ``yy`'. The precise list of symbols renamed is `yyparse`, `yylex`, `yyerror`, `yynerrs`, `yylval`, `yychar` and `yydebug`.

  For example, if you use ``-p c`', the names become `cparse`, `clex`, and so on.

  See section Multiple Parsers in the Same Program.

``-r`'
``--raw`'
  Pretend that `%raw` was specified. See section 3.6.8 Bison Declaration Summary.

``-t`'
``--debug`'
  Output a definition of the macro `YYDEBUG` into the parser file, so that the debugging facilities are compiled. See section Debugging Your Parser.

``-v`'
``--verbose`'
  Write an extra output file containing verbose descriptions of the parser states and what is done for each type of look-ahead token in that state.

  This file also describes all the conflicts, both those resolved by operator precedence and the unresolved ones.

  The file's name is made by removing ``.tab.c`' or ``.c`' from the parser output file name, and adding ``.output`' instead.

  Therefore, if the input file is ``foo.y`', then the parser file is called ``foo.tab.c`' by default. As a consequence, the verbose output file is called ``foo.output`'.

``-V`'
``--version`'
  Print the version number of Bison and exit.

``-h`'
``--help`'
  Print a summary of the command-line options to Bison and exit.

``-y`'
``--yacc`'
``--fixed-output-files`'
  Equivalent to ``-o y.tab.c`'; the parser output file is called ``y.tab.c`', and the other outputs are called ``y.output`' and ``y.tab.h`'. The purpose of this option is to imitate Yacc's output file name conventions. Thus, the following shell script can substitute for Yacc:

      bison -y $*

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 9.2 Option Cross Key

Here is a list of options, alphabetized by long option, to help you find the corresponding short option.

    --debug                               -t
    --defines                             -d
    --file-prefix=prefix                  -b file-prefix
    --fixed-output-files --yacc           -y
    --help                                -h
    --name-prefix=prefix                  -p name-prefix
    --no-lines                            -l
    --no-parser                           -n
    --output-file=outfile                 -o outfile
    --raw                                 -r
    --token-table                         -k
    --verbose                             -v
    --version                             -V

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 9.3 Invoking Bison under VMS

The command line syntax for Bison on VMS is a variant of the usual Bison command syntax--adapted to fit VMS conventions.

To find the VMS equivalent for any Bison option, start with the long option, and substitute a ``/`' for the leading ``--`', and substitute a ``_`' for each ``-`' in the name of the long option. For example, the following invocation under VMS:

    bison /debug/name_prefix=bar foo.y

is equivalent to the following command under POSIX.

    bison --debug --name-prefix=bar foo.y

The VMS file system does not permit filenames such as ``foo.tab.c`'. In the above example, the output file would instead be named ``foo_tab.c`'.

[ << ] | [ >> ] |  |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

This document was generated by Frank B. Brokken on January, 28 2005 using texi2html